
;THIS ROUTINE STORES THE ATTRIBUTES FOR THE MAP TILES

SETATTRIBS:
    STX <$04                   ;ATTRIBUTES TABLE POINTER LB
    STA <ROW                   ;ATTRIBUTES TABLE POINTER HB
    STY <COLUMN                ;MAP HEADER INDEX
    LDY #$3F                   ;THERE IS 64 ATTRIBUTES FOR A MAP
SETATTRIBLOOP:
    LDA [$04], Y               ;GET ATTRIBUTE BYTE
    STA $0600, Y               ;SAVE IT
    DEY
    BPL SETATTRIBLOOP
    LDY <COLUMN                ;MAP HEADER INDEX
    RTS

;THIS ROUTINE GETS THE NEXT DATA POINTER FROM THE MAP HEADER

SETHEADERINDEX:
    ASL A
    TAY
GETPOINTER:
    LDA [$4F], Y               ;GET DATA POINTER LB
    TAX
    INY
    LDA [$4F], Y               ;GET DATA POINTER HB
    INY
    RTS

;THIS ROUTINE READS THE MAP HEADER AND SETS THINGS UP

GETMAPINFO1:
    BIT <MAPNMBR
    BVS GETMAPINFO2
    LDA #$00
    JSR SETHEADERINDEX
    STX <$42
    TAX
    AND #$3F
    STA <$43
    TXA
    ROL A
    ROL A
    ROL A
    AND #$03
    STA $0418
GETMAPINFO2:
    LDA #$01
    JSR SETHEADERINDEX         ;MAP WIDTH AND HEIGHTH
    STX <MAPWIDTH
    STA <MAPHEIGHTH
    JSR GETPOINTER             ;POINTER TO SPRITE DATA
    STX <$51
    STA <$52
    JSR GETPOINTER             ;POINTER TO METATILE TABLE
    STX <$59
    STA <$5A
    JSR GETPOINTER             ;POINTER TO METATILE ATTRIBUTES TABLE
    JSR SETATTRIBS
    JSR GETPOINTER             ;POINTER TO BG PALETTE
    TAY
    TXA
    JMP LOADPALETTE            ;LOAD THE BG PALETTE

;THIS ROUTINE SETS UP THE MAP, READS IT FROM ROM TO RAM, DRAWS IT ON THE SCREEN, ETC.

SETUPMAP:
    JSR GETMAPINFO1            ;GET MAP HEADER INFO
    LDA #$0C                   ;THE HEADER IS 12 BYTES (FOR NOW)
    LDX <$50
    CLC
    ADC <$4F
    BCC DONTINCX
    INX
DONTINCX:
    STA <COLUMN
    STX <$07
    JSR LOADMAP                ;DECOMPRESS A MAP FROM ROM TO SAVE RAM
    RTS

